'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const Comment = 1,
  MultilineComment = 2,
  Slash = 3,
  Backslash = 4,
  MultilineCommentToEOF = 5,
  Minus = 6,
  Number = 7;

/* Hand-written tokenizers for K tokens that can't be
   expressed by lezer's built-in tokenizer. */

const A = 65, a = 97, backslash = 92, closeBrackets = 125, closeParenthesis = 41,
    closeSquareBrackets = 93, e = 101, eof = -1, minus = 45, newline = 10, nine = 57, period = 46,
    slash = 47, space = 32, x = 120, Z = 90, z = 122, zero = 48;

// This tokenizer is needed to determine whether a `/` is used as an adverb or is
// the beginning of a comment. This requires looking at the previous character and
// the position in the input. This tokenizer is also used to parse multiline comments.
const slashOrComment = new lr.ExternalTokenizer(input => {
    if (input.next !== slash) {
        return;
    }

    const prev = input.peek(-1);
    const pos = input.pos;
    input.advance();

    if (prev !== space && prev !== newline && pos !== 0) {
        input.acceptToken(Slash);
        return;
    }

    if (input.next === newline && (prev === newline || pos === 0)) {
        // It's a multiline comment.
        while (input.next !== eof) {
            if (input.next === backslash && input.peek(-1) === newline) {
                input.advance();
                if (input.next === newline) {
                    break;
                }
            }
            input.advance();
        }
        input.acceptToken(MultilineComment);
        return;
    }

    while (input.next !== newline && input.next !== eof) {
        input.advance();
    }
    input.acceptToken(Comment);
});

// This tokenizer is needed to determine whether a `\` is used as an adverb or is
// the beginning of a comment to the end of the file. This requires looking at the previous
// character and the position in the input.
const backslashOrMultilineCommentToEOF = new lr.ExternalTokenizer(input => {
    if (input.next !== backslash) {
        return;
    }

    const prev = input.peek(-1);
    const pos = input.pos;
    input.advance();

    if (input.next === backslash && (pos === 0 || prev === newline)) {
        input.advance();

        if (input.next === newline || input.next === eof) {
            input.advance();
            while (input.next !== eof) {
                input.advance();
            }
            input.acceptToken(MultilineCommentToEOF);
            return;
        }
        return;
    }

    input.acceptToken(Backslash);
});

// This tokenizer is needed to determine whether a `-` is used as an verb or
// the beginning of a number. This requires looking at the previous character.
// This tokenizer also includes full support for parsing floating point numbers
// and is a convenient way to avoid some overlapping tokens, such as `.e`, that
// would occur when using the built-in tokenizer.
const minusOrNumber = new lr.ExternalTokenizer(input => {
    if (input.next >= zero && input.next <= nine && input.peek(1) !== x) {
        parseNumber(input);
        input.acceptToken(Number);
        return;
    }

    if (input.next !== minus) {
        return;
    }

    const prev = input.peek(-1);

    input.advance();

    if ((prev < zero || prev > nine) && (prev < A || prev > Z) && (prev < a || prev > z) &&
        prev !== closeBrackets && prev !== closeParenthesis && prev !== closeSquareBrackets) {
        if (parseNumber(input)) {
            input.acceptToken(Number);
            return;
        }
    }

    input.acceptToken(Minus);
});

const parseNumber = input => {
    let isNumber;
    while (input.next >= zero && input.next <= nine) {
        isNumber = true;
        input.advance();
    }

    if (isNumber) {
        if (input.next === period) {
            input.advance();
        }

        while (input.next >= zero && input.next <= nine) {
            input.advance();
        }

        if (input.next === e) {
            input.advance();

            if (input.next === minus) {
                input.advance();
            }

            while (input.next >= zero && input.next <= nine) {
                input.advance();
            }
        }
    }
    return isNumber;
};

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "#rQVQ_OOOOQ^'#Cy'#CyOOQ^'#Cz'#CzOOQ^'#C{'#C{O!WQ_O'#CpO!_Q_O'#CsOOQ^'#Cx'#CxO!fQ_O'#CtQVQ_OOOOQ^,59[,59[O#vQ_O,59[OOQ^,59_,59_O#}Q_O,59_O$UQ_O'#CmOOQ^,59d,59dOOQ^-E6r-E6rOOQ^1G.v1G.vOOQ^1G.y1G.yOOQ^,59X,59XO$]Q_O,59XOOQ^1G.s1G.s",
  stateData: "$d~OkOS~OPUOQUORROSROTUOUQOVPOXPOYPOZPO[QO]RO^UOcSOfTO~ObXO~PVOeZO~PVO`]OPhXQhXRhXShXThXUhXVhXXhXYhXZhX[hX]hX^hXchXfhXihXbhXehX_hX~Ob`O~PVOeaO~PVO_bO~PVO_dO~PVO",
  goto: "!lpPPPPPPPPPPPPPPPPPqPPtPPt!OPPP!btttR^VaUOSTWY[]cQWOQYSQ[TW_WY[cRc]aVOSTWY[]c",
  nodeNames: "⚠ Comment MultilineComment Slash Backslash MultilineCommentToEOF Minus Number Program Name String Symbol Verb Adverb Delimiter ] [ SquareBrackets ) ( Parentheses } { Function",
  maxTerm: 31,
  nodeProps: [
    ["openedBy", 15,"[",18,"(",21,"{"],
    ["closedBy", 16,"]",19,")",22,"}"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "*^~RuXY#fYZ#f]^#fpq#fqr#wrs$Ust#wtu#wuv#wvw#wwx%Pxy%^yz%cz{#w{|#w|}#w!O!P#w!Q!R%h!R![&V![!]#w!]!^&]!^!_#w!_!`#w!`!a#w!a!b#w!b!c#w!c!}&b!}#O&|#P#Q'R#Q#R#w#R#S#w#S#T'W#T#o&b#o#p*S#p#q#w#q#r*X#r#s#w~#kSk~XY#fYZ#f]^#fpq#f~#|P[~![!]$P~$UO[~~$XVOY$UYZ$nZr$Urs$ts#O$U#O#P$y#P~$U~$qPpq$U~$yOY~~$|PO~$U~%UP]~![!]%X~%^O]~~%cOc~~%hOb~~%kQ![!]#w#l#m%q~%vQY~!Q![%|#T#Z%|~&PQ!Q![%q#T#Z%q~&YP![!]#w~&bO^~~&gSX~!O!P&s!Q![&b!c!}&b#T#o&b~&vQ!c!}&b#T#o&b~'RO`~~'WO_~~']WZ~rs'u!Q!R(p!c!})[#T#o)[#t;'S(e;'S;=_)v;=_;=`)|<%l~(e~'xVOY'uYZ(_Zr'urs(es#O'u#O#P(j#P~'u~(bPpq'u~(jOZ~~(mPO~'u~(sP#l#m(v~({QZ~!Q![)R#T#Z)R~)UQ!Q![(v#T#Z(v~)aSZ~!O!P)m!Q![)[!c!})[#T#o)[~)pQ!c!})[#T#o)[~)yP;=`<%l(e~*PP;=`<%k(e~*XOf~~*^Oe~",
  tokenizers: [0, slashOrComment, backslashOrMultilineCommentToEOF, minusOrNumber],
  topRules: {"Program":[0,8]},
  tokenPrec: 0
});

const kLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            highlight.styleTags({
                "( )": highlight.tags.paren,
                "[ ]": highlight.tags.squareBracket,
                "{ }": highlight.tags.bracket,
                Adverb: highlight.tags.operator,
                Backslash: highlight.tags.operator,
                Comment: highlight.tags.lineComment,
                Delimiter: highlight.tags.separator,
                Minus: highlight.tags.operator,
                MultilineComment: highlight.tags.blockComment,
                MultilineCommentToEOF: highlight.tags.blockComment,
                Name: highlight.tags.name,
                Number: highlight.tags.number,
                Slash: highlight.tags.operator,
                String: highlight.tags.string,
                Symbol: highlight.tags.constant(highlight.tags.name),
                Verb: highlight.tags.operator,
            })
        ]
    }),
    languageData: {
        commentTokens: { line: "/" },
        closeBrackets: { brackets: ["(", "[", "{", '"'] },
    }
});
function k() {
    return new language.LanguageSupport(kLanguage);
}

exports.k = k;
exports.kLanguage = kLanguage;
